#!/usr/bin/python

from glob import glob
import os, sys, struct
from sys import argv
from stat import *

PALETTEID = 0x987b4789

def readfile(name):
	try:
		fd = open(name, "rb")
		contents = fd.read()
		fd.close()
	except IOError:
		print "Error reading", name
		sys.exit(1)
	return contents

def writefile(name, contents):
	try:
		fd = open(name, "wb")
		fd.write(contents)
		fd.close()
	except IOError:
		print "Error writing", name
		sys.exit(1)

def parse(file):
	title = file.rsplit("/", 1)[-1].rpartition(".")
	if title[0] == "":
		title = title[2][0:20]
	else:
		title = title[0][0:20]
	lines = 0
	txt = readfile(file)
	rgb = ""
	for f in txt.splitlines():
		line = f.partition(";")[0].strip()
		if line != "":
			if lines == 4:
				return 1
			lines += 1
			values = line.split(",")
			if len(values) != 12:
				return 1
			for v in values:
				v = v.strip()
				if v[0:2] == "0x" or v[0:2] == "0X":
					i = int(v, 16)
				else:
					i = int(v)
				if i < 0 or i > 255:
					return 1
				rgb = rgb + struct.pack("B", i)
	if lines != 4:
		return 1
	pal = struct.pack("<I", PALETTEID) + rgb + struct.pack("20sI", title, 0)
	outfile = file.rpartition(".")
	if outfile[0] == "":
		outfile = outfile[2] + ".pal"
	else:
		outfile = outfile[0] + ".pal"
	writefile(outfile, pal)
	return 0

if __name__ == "__main__":
	if len(argv) == 1:
		print "Usage: %s [palette.txt ...]"
		sys.exit(0)
	if sys.platform == "win32":
		tmp = []
		for a in argv[1:]:
			expanded = glob(a)
			if len(expanded) == 0:
				tmp.append(a)
			else:   
				tmp.extend(expanded)
		args = tmp
	else:
		args = argv[1:]
	for f in args:
		if parse(f):
			print "Invalid palette text file: %s" % f
